REM codigo batch para respaldar automaticamente una base de datos -COMPLETA-
REM este codigo recibe parametros externos
REM Ing. Mario Jonathan Rodriguez Hernandez

REM title permite poner titulo al comand prompt
title "AduanaSoft.exe"
REM @ECHO OFF permite eliminar de la vista dle usuario la direccion de linea de comando
@ECHO OFF 
REM color lleve dos parametros , Fondo y color de letras , trabaja en Hexadecimal
color F0
REM las variables amarillas de un numero , son los parametros que recibe la aplicacion

REM las siguientes variables contienen la configuracion para respaldar la BD
REM server mantiene el nombre del servidor y la instancia SQL
set server=%~1
REM bd es el nombre de la base de datos
set bd=%~2
REM nombrerespaldo es el nombre que le daremos al respaldo de la BD
REM CLS permite limpiar la pantalla
CLS
REM echo permite visualizar palabras o variables en pantalla
echo	Base de Datos - %bd%
echo	La base de datos sera guardada con el siguiente nombre:
echo	%3 , deseas cambiarlo?
REM set permite asignar un valor a un variable
REM en este caso le damos un valor por defecto de 1 , para que si el usuario
REM no le proporciona un valor no genere error
set pre=1
echo	Presiona 1 para continuar o presiona 2 para modificar el nombre
REM echo. tiene la funcion de un enter al momento de visualizar palabras o variables en pantalla
echo. 
REM poner /p antes del nombre de la variable permite que el usuario proporcione el valor
REM en tiempo de ejecucion , dedes poner despues del = la pregunta a contestar y :
REM al termino de la pregunta para que indique el fin de la pregunta
REM en este caso no nesesitamos pregunta , por lo cual no lleva :
set /p pre= 
REM if nos permitira hacer una condicion , en este caso preguntamos si la respuesta del usuario
REM es igual a 2 , si es verdadera iria a una seccion de codigo , sin embargo , si la primera no
REM se cumple , forzosamente caera en la segunda condicion para ir a otra seccion de codigo
if %pre%==2 goto conmodificacion
if %pre%==%pre% goto sinmodificacion




REM estos pedazos de codigo son etiquetas , sirven para trasladarse atravez del codigo
REM en este caso , la condicion superior indicara a que etiqueta debe ir
REM las etiquetas deben comenzar con : y ser llamadas con un GOTO
:sinmodificacion
REM la etiqueta de sinmodificacion le da un nombre por defecto
set nombrerespaldo=%~3
REM goto nos servira para direccionar el flujo del codigo , indicando que etiqueta debe
REM ser ejecutada a continuacion
goto continuacion
:conmodificacion
REM la etiqueta conmodificacion permite dar un nombre a placer
REM siempre y cuando cumpla con las condiciones mostradas debajo
CLS
echo	Base de Datos - %bd%
echo	Con que nombre se guardara el respaldo??:
echo.
set mensaje=" \ / : * ? < > | "
echo	Nota: el nombre no acepta los 
echo	siguientes caracteres especiales :
echo	%mensaje%
echo. 
set /p nombrerespaldo=
goto continuacion




REM en la parte superior del codigo se selecciono el nombre con el cual se guardara el respaldo
REM de la base de datos , esta seccion indica la ruta donde se grabara y ademas corre la sentencia
REM SQL para generar el respaldo correspondiente
:continuacion
set rutax=%~4
CLS
REM mkdir se asegura que la direccion en donde se almacenara el respaldo de la base de datos
REM exista , de no ser asi , la crea
mkdir %4
CLS
REM ruta es la direccion donde se guardara el respaldo
set ruta="%~4\%nombrerespaldo%.bak"
REM la linea inferior muestra la consulta SQL requerida para respaldar el archivo
REM no es nesesario modificarla debido a los parametros superiores

sqlcmd -U %~5 -P %~6 -S %~1 -Q "BACKUP DATABASE [%~2] TO DISK = N'%~4\%nombrerespaldo%.bak' WITH INIT, NAME = N'Automatic back up of database', STATS = 1"

REM se crea un variable con un valor predeterminado 0
REM esta permitira verificar si el archivo .bak se creo
set myvar=0
REM /p antes de la variable permite asignar el valor de un archivo a esta
REM pero es nesesario direccionarla con =<
set /p myvar=<%ruta%
REM echo %myvar% permite mostrar el valor que tiene la variable despues de darle un nuevo valor
REM esta operacion desaparecera una vez sean concluidas las pruebas
echo %myvar%

REM en el caso que el archivo no exista , la variable no se vera afectada en su valor 0
REM si existe el archivo el valor que toma la variable es diferente de 0
REM dependiendo del valor de la variable es a donde se dirige el codigo
if %myvar% == 0 goto malfin
IF %myvar% == %myvar% goto fin

REM malfin existe para realizar la operacion de respaldo por medio de la herramienta OSQL
:malfin
REM msg * permite agregar un mensaje desplegable al usuario para mostrar si el archivo existe o no
REM msg * No Existe el archivo
REM OSQL es un antiguo modelo de SQLCMD , el query permanece intacto
osql -U %~5 -P %~6 -S %~1 -Q "BACKUP DATABASE [%~2] TO DISK = N'%~4\%nombrerespaldo%.bak' WITH INIT, NAME = N'Automatic back up of database', STATS = 1"
goto finfin

REM fin existe para demostrar que el archivo existe y no nesesita un segundo proceso de respaldo
:fin
REM msg * permite agregar un mensaje desplegable al usuario para mostrar si el archivo existe o no
REM msg * Existe el archivo
goto finfin

:finfin
REM una vez generado el respaldo se procede a mostrar la ruta en donde se almaceno
REM ademas de crear un archivo comprimido del respaldo , unicamente si asi se desea

CLS
echo	Proceso terminado , la base de Datos %bd% se almaceno en 
echo	%ruta% 
echo	Presiona cualquier tecla para continuar...
REM pause permite pausar la ejecucion del programa en puntos clave seleccionados por el creador
REM en este caso se agregar un >nul para eliminar el mensaje por defecto
pause>nul
CLS
echo	Deseas comprimir el respaldo
echo	Presiona 1 para comprimir tu respaldo o 2 para salir
echo. 
set ask=2
set /p ask= 
if %ask%==1 goto comprimir
if %ask%==%ask% goto salir
CLS




REM si se elegio comprimir el respaldo , este sera generado con el mismo nombre
REM y la misma direccion , sin embargo , la extension del archivo comprimido
REM sera de .rar
:comprimir
REM se utiliza winrar como compresor por ello instalalo en la ruta mostrada debajo
REM para que no surja ningun error , igual puedes modificar la direccion al ejecutable
REM en este caso se tendran las dos posibles direcciones por defecto de winrar
REM para que de esta manera genera la compresion sin problemas
"C:\Program Files\WinRAR\WinRAR.exe" A -R  %4\"%nombrerespaldo%".rar %4\"%nombrerespaldo%".bak
"C:\Archivos de Programa\WinRAR\WinRAR.exe" A -R %4\"%nombrerespaldo%".rar %4\"%nombrerespaldo%".bak
CLS
echo	Proceso terminado , se comprimio la base de Datos %bd% en 
echo	%ruta% 



:salir
echo	Presiona cualquier tecla para terminar.
pause>nul
REM exit permite salir de la linea de comando , terminando el programa
exit